-- globals
local ADDON =  "SlashParty";
local VERSION = GetAddOnMetadata(ADDON, "Version") or "Unknown Verson";
local TITLE = GetAddOnMetadata(ADDON, "Title") or "UnKnown Title";

realm = GetRealmName("player");
player = GetUnitName("player");


local frame = CreateFrame("FRAME", "SlashPartyFrame");
frame:RegisterEvent("ADDON_LOADED");


function SlashPartyFrame_OnEvent(frame, event, ...)

	if event == "ADDON_LOADED" then
		if not SlashPartyData then
			SlashPartyData = {};
		end
	end

end

SlashCmdList['SlashLeave_SLASHCMD'] = function()
	LeaveParty();

	local numBattlefields = GetMaxBattlefieldID();
	if numBattlefields then
		for i = 1,numBattlefields do
			local status, mapName, instanceID, bracketMin, bracketMax, teamSize, registeredMatch = GetBattlefieldStatus(i);
			if status == "active" then
				LeaveBattlefield();
			end
		end
	end
	
end
SLASH_SlashLeave_SLASHCMD1 = '/leave';
SLASH_SlashLeave_SLASHCMD2 = '/lv';

SlashCmdList['SlashMakeRaid_SLASHCMD'] = function()
	if GetNumGroupMembers() and UnitIsGroupLeader("player") then
		ConvertToRaid();
	else
		print("You must be the leader of a party to make a raid.");
	end
	
end
SLASH_SlashMakeRaid_SLASHCMD1 = '/makeraid';

SlashCmdList['SlashMakeParty_SLASHCMD'] = function()
	if GetNumGroupMembers() and UnitIsGroupLeader("player") and GetNumGroupMembers() <= 5 then
		ConvertToParty();
	else
		print("You must be the raid leader of a group with at most 5 players to convert to party.");
	end
end
SLASH_SlashMakeParty_SLASHCMD1 = '/makeparty';

SlashCmdList['SlashReset_SLASHCMD'] = function()
	if GetNumGroupMembers() and UnitIsGroupLeader("player") then
		ResetInstances();
		print("Reset Command Sent.");
	end
end
SLASH_SlashReset_SLASHCMD1 = '/reset';

SlashCmdList['SlashTele_SLASHCMD'] = function()
	if IsInInstance() then
		LFGTeleport(true);
	else
		LFGTeleport();
	end
end
SLASH_SlashTele_SLASHCMD1 = '/tele';

SlashCmdList['SlashSetRaid_SLASHCMD'] = function(data)
	if GetNumGroupMembers() and UnitIsGroupLeader("player") then
		if data == "10" then
			SetRaidDifficulty(1);
		end
		if data == "25" then
			SetRaidDifficulty(2);
		end
		if data == "10h" then
			SetRaidDifficulty(3);
		end
		if data == "25h" then
			SetRaidDifficulty(4);
		end

	end
end
SLASH_SlashSetRaid_SLASHCMD1 = '/setraid';	

SlashCmdList['SlashSetLoot_SLASHCMD'] = function(data)
	if GetNumGroupMembers() and UnitIsGroupLeader("player") then
		local theshold = nil;
		local method = nil;

		local flag1, flag2 = strsplit(" ", data, 2);

		if not flag1 then flag1 = "null" end
		if not flag2 then flag2 = "null" end

		if 	flag1 == "uncommon" or 
			flag2 == "uncommon" or
			flag1 == "green" or 
			flag2 == "green" then
			threshold = 2;
		end

		if 	flag1 == "rare" or 
			flag2 == "rare" or
			flag1 == "blue" or 
			flag2 == "blue" then
			threshold = 3;
		end

		if 	flag1 == "epic" or 
			flag2 == "epic" or
			flag1 == "purple" or 
			flag2 == "purple" then
			threshold = 4;
		end

		if 	flag1 == "legendary" or 
			flag2 == "legendary" or
			flag1 == "orange" or 
			flag2 == "orange" then
			threshold = 5;
		end

		if flag1 == "group" or flag2 == "group" then
			method = "group";
		end

		if flag1 == "ffa" or flag2 == "ffa" then
			method = "freeforall";
		end

		if flag1 == "master" or flag2 == "master" then
			method = "master";
		end

		if flag1 == "need" or flag2 == "need" then
			method = "needbeforegreed";
		end

		if flag1 == "round" or flag2 == "round" then
			method = "roundrobin";
		end

		print(method,threshold);
		if threshold then SetLootThreshold(tonumber(threshold)); end
		if method then SetLootMethod(method,UnitName("Player")); end
		
	else
		print("You must be the leader of a group to set loot.");
	end
end
SLASH_SlashSetLoot_SLASHCMD1 = '/setloot';

print("SlashParty Loaded!")
